(************************************************************************
*    This File is Part of the AHM Triton Tools                          *
*    for Borland Delphi and C++ Builder.                                *
*************************************************************************
* Copyright  1995-2000 Alexander H. Mehlhorn (AHM) and Tritontools.com *
* All Rights reserved.                                                  *
*                                                                       *
*    For more Information contact us at                                 *
*    E-Mail : support@tritontools.com                                   *
*    URL : http://www.tritontools.com                                   *
*                                                                       *
*    AHM is copyright by Alexander H. Mehlhorn                          *
*    All Parts of this Collection were developed,                       *
*    designed and implemented by AHM                                    *
*                                                                       *
*    Under no Circumstances may you distribute this file                *
*    in this or any other format. This File is supplied                 *
*    as Evaluation of Source only. No Delphi Components may be developed*
*    using extracts or subsets of this code without expressed permission*
*    by AHM.                                                            *
*                                                                       *
*************************************************************************)
unit AHMTLeds;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls,
  Graphics,Extctrls,AHMfreeware;

Type
 TAHMLed = class(TGraphicControl)
  private
    FAbout : TAHMAboutFreeStr;
     finter : Integer;
     frun : Boolean;
     fled : Boolean;
     ftim : TTimer;
     fdon,fdoff,fback : TColor;
     fccol : TColor;
     procedure Setfdon(value : TColor);
     procedure Setfdoff(value : TColor);
     procedure Setback(value : TColor);
     Procedure SeTAHMLed(value : Boolean);
     Procedure Setrun(value : Boolean);
     Procedure SetInter(value : Integer);
  protected
    procedure Paint; Override;
    procedure Runit(Sender : TObject);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    Procedure LedOn;
    Procedure LedOff;
    Procedure Blink;
  published
    Property About : TAHMAboutFreeStr read FAbout write FAbout;
    property OnClick;
    Property OnDblClick;
    Property Visible;
    Property LedisOn : Boolean read fled write seTAHMLed;
    Property LedOnColor : Tcolor read fdon write setfdon;
    Property LedOffColor : TColor read fdoff write setfdoff;
    Property LedShadow : TColor read fback write Setback;
    Property Interval : Integer read finter write SetInter;
    Property Blinking : Boolean read frun write Setrun;
    Property Hint;
    Property ShowHint;
  end;

implementation

constructor TAHMLed.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  height:=15;
  width:=15;
  fdoff:=clGreen;
  fdon:=clRed;
  fback:=clWhite;
  fccol:=clgreen;
  finter:=200;
  fled:=false;
  frun:=false;
  ftim:=TTimer.create(Self);
  ftim.onTimer:=Runit;
  ftim.enabled:=frun;
  ftim.Interval:=finter;

end;

procedure TAHMLed.Runit(Sender : TObject);
begin
  if fled then fled:=false
  else fled:=true;
  invalidate;
end;

destructor TAHMLed.Destroy;
begin
  ftim.free;
  inherited destroy;
end;

Procedure TAHMLed.Setfdon(value : TColor);
begin
  fdon:=value;
  paint;
end;

Procedure TAHMLed.Setfdoff(value : TColor);
begin
  fdoff:=value;
  Invalidate;
end;

Procedure TAHMLed.Setback(value : TColor);
begin
  fback:=value;
  invalidate;
end;


Procedure TAHMLed.SeTAHMLed(value : Boolean);
begin
  if value then fccol:=fdon;
  fccol:=fdoff;
  fled:=value;
  invalidate;
end;

Procedure TAHMLed.Setrun(value : Boolean);
begin
  ftim.enabled:=value;
  frun:=value;
  invalidate;
end;

Procedure TAHMLed.LedOn;
begin
  ftim.enabled:=false;
  fled:=true;
  Invalidate;
end;

Procedure TAHMLed.LedOff;
begin
  ftim.enabled:=false;
  fled:=false;
  invalidate;
end;

Procedure TAHMLed.Blink;
begin
  if ftim.enabled then ftim.enabled:=false
  else ftim.enabled:=true;
  fled:=false;
  invalidate;
end;

Procedure TAHMLed.SetInter(value : Integer);
begin
    ftim.Interval:=value;
    finter:=value;
end;


procedure TAHMLed.Paint;
begin
  with canvas do
  begin
    height:=15;
    width:=15;
    pen.width:=1;
    pen.color:=clgray;
    if fled then brush.color:=fdon
    else brush.color:=fdoff;
    ellipse(2,2,14,14);
    pixels[6,5]:=fback;
    pixels[7,5]:=fback;
    pixels[8,5]:=fback;
    pixels[5,6]:=fback;
    pixels[5,7]:=fback;
    pixels[5,8]:=fback;
    pixels[6,6]:=fback;
    pixels[6,7]:=fback;
    pixels[7,6]:=fback;
  end;
end;

end.
