(************************************************************************
*    This File is Part of the AHM Triton Tools                          *
*    for Borland Delphi and C++ Builder.                                *
*************************************************************************
* Copyright  1995-2000 Alexander H. Mehlhorn (AHM) and Tritontools.com *
* All Rights reserved.                                                  *
*                                                                       *
*    For more Information contact us at                                 *
*    E-Mail : support@tritontools.com                                   *
*    URL : http://www.tritontools.com                                   *
*                                                                       *
*    AHM is copyright by Alexander H. Mehlhorn                          *
*    All Parts of this Collection were developed,                       *
*    designed and implemented by AHM                                    *
*                                                                       *
*    Under no Circumstances may you distribute this file                *
*    in this or any other format. This File is supplied                 *
*    as Evaluation of Source only. No Delphi Components may be developed*
*    using extracts or subsets of this code without expressed permission*
*    by AHM.                                                            *
*                                                                       *
*************************************************************************)
unit AHMTMenuItemGlyph;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     Menus,AHMFreeware;

type
  TAHMMenuItemGlyph = class(TComponent)
  private
    FAbout : TAHMAboutFreeStr;
    FGlyph: TBitmap;
    FCheckGlyph: TBitmap;
    FMenuItem: TMenuItem;
    procedure SetGlyph(value: TBitmap);
    procedure SetCheckGlyph(value: TBitmap);
  protected
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Refresh;
    procedure Loaded; override;
  published
    Property About : TAHMAboutFreeStr read FAbout write FAbout;
    property CheckGlyph: TBitmap read FCheckGlyph write SetCheckGlyph;
    property ItemGlyph: TBitmap read FGlyph write SetGlyph;
    property MenuItem: TMenuItem read FMenuItem write FMenuItem;
  end;

implementation

procedure TAHMMenuItemGlyph.SetGlyph(value: TBitmap);
begin
  FGlyph.Assign(value);
end;

procedure TAHMMenuItemGlyph.SetCheckGlyph(value: TBitmap);
begin
  FCheckGlyph.Assign(value);
end;

procedure TAHMMenuItemGlyph.Refresh;
begin
  if (FMenuItem <> nil) then
  begin
    if (FMenuItem.Checked) and (FCheckGlyph <> nil) then
       SetMenuItemBitmaps(FMenuItem.Parent.Handle, FMenuItem.Command, MF_BYCOMMAND, FGlyph.Handle, FCheckGlyph.Handle)
    else if (FGlyph <> nil) then
       SetMenuItemBitmaps(FMenuItem.Parent.Handle, FMenuItem.Command, MF_BYCOMMAND, FGlyph.Handle, FGlyph.Handle);
  end;
end;

procedure TAHMMenuItemGlyph.Loaded;
begin
  inherited Loaded;
  Refresh;
end;

constructor TAHMMenuItemGlyph.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FCheckGlyph := TBitmap.Create;
  FGlyph := TBitmap.Create;
end;

destructor TAHMMenuItemGlyph.Destroy;
begin
  FCheckGlyph.Free;
  FGlyph.Free;
  inherited Destroy;
end;

end.
